import link from './linker';
import { Environment } from './model';
import { List } from './extensions';
import * as parse from './parser';
import { ParseError } from './parser';
import validate from './validator';
import print from './printer/print';
import WRE from './wre/wre.json';
import WRENatives from './wre/wre.natives';
import natives from './wre/natives';
export type FileContent = {
    name: string;
    content: string;
};
declare function buildEnvironment(files: List<FileContent>, baseEnvironment?: Environment): Environment;
export * from './constants';
export * from './extensions';
export * from './helpers';
export * from './linker';
export * from './jsonUtils';
export * from './model';
export * from './interpreter/interpreter';
export * from './interpreter/dynamicDiagram';
export * from './interpreter/runtimeModel';
export * from './typeSystem/constraintBasedTypeSystem';
export * from './printer/exceptions';
export * from './printer/utils';
export * from './validator/messageReporter';
export { buildEnvironment, link, parse, ParseError, validate, print, WRE, WRENatives, natives, };
