"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMessage = exports.LANGUAGES = void 0;
const convertToHumanReadable = (code, customMessages, language) => {
    if (!code) {
        return '';
    }
    const result = code.replace(/[A-Z0-9]+/g, (match) => ' ' + match.toLowerCase());
    return (validationI18nized(customMessages, language)[FAILURE] +
        result.charAt(0).toUpperCase() +
        result.slice(1, result.length));
};
const interpolateValidationMessage = (message, ...values) => message.replace(/{\d*}/g, (match) => {
    var _a;
    const index = match.replace('{', '').replace('}', '');
    return (_a = values[+index]) !== null && _a !== void 0 ? _a : '';
});
const validationI18nized = (customMessages, language) => customMessages[language];
var LANGUAGES;
(function (LANGUAGES) {
    LANGUAGES["SPANISH"] = "es";
    LANGUAGES["ENGLISH"] = "en";
})(LANGUAGES = exports.LANGUAGES || (exports.LANGUAGES = {}));
const getMessage = ({ message, values, language = LANGUAGES.ENGLISH, customMessages = messages }) => interpolateValidationMessage(validationI18nized(customMessages, language)[message] || convertToHumanReadable(message, customMessages, language), ...values !== null && values !== void 0 ? values : []);
exports.getMessage = getMessage;
const en_json_1 = __importDefault(require("./en.json"));
const es_json_1 = __importDefault(require("./es.json"));
const FAILURE = 'failure';
const messages = {
    [LANGUAGES.ENGLISH]: Object.assign(Object.assign({}, en_json_1.default), { [FAILURE]: 'Rule failure: ' }),
    [LANGUAGES.SPANISH]: Object.assign(Object.assign({}, es_json_1.default), { [FAILURE]: 'La siguiente regla falló: ' }),
};
//# sourceMappingURL=messageReporter.js.map