"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const runtimeModel_1 = require("../interpreter/runtimeModel");
const mirror = {
    ObjectMirror: {
        *resolve(self, attributeName) {
            var _a;
            (0, runtimeModel_1.assertIsString)(attributeName, 'resolve', 'attributeName');
            return (_a = self.get('target')) === null || _a === void 0 ? void 0 : _a.get(attributeName.innerString);
        },
        *instanceVariableFor(self, name) {
            (0, runtimeModel_1.assertIsString)(name, 'instanceVariableFor', 'name');
            return yield* this.instantiate('wollok.mirror.InstanceVariableMirror', {
                target: self,
                name,
            });
        },
        *instanceVariables(self) {
            const values = [];
            for (const field of self.get('target').module.allFields)
                values.push((yield* this.send('instanceVariableFor', self, yield* this.reify(field.name))));
            return yield* this.list(...values);
        },
    },
};
exports.default = mirror;
//# sourceMappingURL=mirror.js.map