"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const wre_natives_1 = __importDefault(require("./wre.natives"));
const natives = (nativeList = []) => merge(mergeList(nativeList), wre_natives_1.default);
const mergeList = (nativeList = []) => nativeList.reduce((merged, current) => merge(merged, current), {});
const merge = (base, incoming) => {
    const keys = new Set([...Object.keys(base), ...Object.keys(incoming)]);
    return [...keys].reduce((result, key) => {
        const baseValue = base[key];
        const incomingValue = incoming[key];
        result[key] = baseValue && incomingValue
            ? merge(baseValue, incomingValue)
            : baseValue !== null && baseValue !== void 0 ? baseValue : incomingValue;
        return result;
    }, {});
};
exports.default = natives;
//# sourceMappingURL=natives.js.map